<?php
/*
Plugin Name: MailChimp
Plugin URI: http://mailchimp.com/api/plugins/wordpress
Description: The MailChimp plugin allows you to easily setup a Subscribe box for your MailChimp list - So easy a chimp could do it!
Version: 0.5
Author: MailChimp API Support Team
Author URI: http://mailchimp.com/api/
*/

/*  Copyright 2008  MailChimp.com  (email : api@mailchimp.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
include_once('MCAPI.class.php');

// some custom CSS//
function mc_admin_css() {
echo "
<style type='text/css'>
.error_msg {
        color: red;
}
.success_msg {
        color: green;
}
}
</style>
";
}
function mc_main_css() {
echo "
<style type='text/css'>
.error_msg {
        color: red;
}
.success_msg {
        color: green;
}
.mc_custom_border{ padding:5px; ";
if (get_option('mc_custom_style')=='on'){
	echo "border-width: ".get_option('mc_form_border_width').'px;';
	echo "border-style: solid;";
	echo "border-color: #".get_option('mc_form_border_color').';';
	echo "color: #".get_option('mc_form_text_color').';';
	echo "background-color: #".get_option('mc_form_background').';';
}
echo "
}
</style>
";
}//mc_main_css

add_action('admin_head', 'mc_admin_css');
add_action('wp_head', 'mc_main_css');

// Hook for adding admin menus
add_action('admin_menu', 'mc_add_pages');

// action function for above hook
function mc_add_pages() {

	//7 is lowest w/ Plugin Editing capability
	add_options_page('MailChimp Setup', 'MailChimp Setup', 7, 'mc_setup_page', 'mc_setup_page');  
}

function mc_setup_page(){
?>
<div class="wrap">
<h2>MailChimp List Setup</h2>
<?php
//see if we need to set/change the username & password.
if (isset($_REQUEST['mc_username']) && isset($_REQUEST['mc_username'])){
	if ($_REQUEST['mc_username']!=get_option('mc_username') || $_REQUEST['mc_password']!=get_option('mc_password')){
		$delete_setup = false;
		$api = new MCAPI($_REQUEST['mc_username'], $_REQUEST['mc_password']);
		if ($api->errorCode == ''){
			$msg = "<span class='success_msg'>Success! We were able to verify your username &amp; password! Let's continue, shall we?</span>";
			update_option('mc_username', $_REQUEST['mc_username']);
			update_option('mc_password', $_REQUEST['mc_password']);
			update_option('mc_user_id', $api->uuid);
			if (get_option('mc_list_id')!=''){
				$lists = $api->lists();
				$delete_setup = true;
				//but don't delete if the list still exists...
				foreach($lists as $list){ if ($list['id']==get_option('mc_list_id')){ $list_id = $_REQUEST['mc_list_id']; $delete_setup=false; } }
			}
		} else {
			$msg = "<span class='error_msg'>Uh-oh, we were unable to login and verify your username &amp; password. Please check them and try again!<br/>";
			$msg .= "The server said: <i>".$api->errorMessage."</i></span>";
			if (get_option('mc_username')==''){
				$delete_setup = true;
			}
		}
		if ($delete_setup){
			delete_option('mc_user_id');
			delete_option('mc_username');
			delete_option('mc_password');
			delete_option('mc_rewards');
			delete_option('mc_list_id');
			delete_option('mc_list_name');
			delete_option('mc_interest_groups');
			delete_option('mc_show_interest_groups');
			$mv = unserialize(get_option('mc_merge_vars'));
			foreach($mv as $var){
				$opt = 'mc_mv_'.$var['tag'];
				delete_option($opt);
			}
			delete_option('mc_merge_vars');
		}
	}
	if (isset($_REQUEST['mc_rewards']) && $_REQUEST['mc_rewards'] != get_option('mc_rewards')){
		update_option('mc_rewards', 'on');
		if ($msg) $msg .= '<br/>';
		$msg .= '<span class="success_msg">Monkey Rewards turned On!</span>';
	} else if (get_option('mc_rewards')!='off') {
		update_option('mc_rewards', 'off');
		if ($msg) $msg .= '<br/>';
		$msg .= '<span class="success_msg">Monkey Rewards turned Off!</span>';
	}
	//set these for the form fields below
	$user = $_REQUEST['mc_username'];
	$pass = $_REQUEST['mc_password'];
} else {
	$user = get_option('mc_username');
	$pass = get_option('mc_password');
}
if (isset($_REQUEST['mc_list_id'])){
	$api = new MCAPI(get_option('mc_username'), get_option('mc_password'));
	$lists = $api->lists();
	foreach($lists as $list){ if ($list['id']==$_REQUEST['mc_list_id']){ $list_id = $_REQUEST['mc_list_id']; $list_name = $list['name']; } }
	if ($list_id == ''){
		$msg = '<span class="error_msg">Uh-oh, something went wrong while trying to load List with ID: '.$_REQUEST['mc_list_id'].'</span>';

	} else {
		update_option('mc_list_id', $list_id);
		update_option('mc_list_name', $list_name);

		update_option('mc_header_content','<h2>Sign up for '.$list_name.'</h2>');
		update_option('mc_submit_text','Subscribe');

		update_option('mc_custom_style','on');
		update_option('mc_form_border_width','1');
		update_option('mc_form_border_color','ccc');
		update_option('mc_form_background','ffffcc');
		update_option('mc_form_text_color','666666');

		$mv = $api->listMergeVars($list_id);
		$ig = $api->listInterestGroups($list_id);
		update_option('mc_merge_vars', serialize( $mv ) );
		foreach($mv as $var){
			$opt = 'mc_mv_'.$var['tag'];
			//turn them all on by default
			update_option($opt, 'on' );
		}
		update_option('mc_interest_groups', serialize( $ig ) );
		update_option('mc_show_interest_groups', 'on' );
		$msg = '<span class="success_msg">Success! Loaded and saved the info for '.sizeof($mv).' Merge Variables and '.
			sizeof($ig).' Interest Groups from your list "'.$list['name'].'"<br/><br/>
			Now you should either Turn On the MailChimp Widget or change your options below, then turn it on.</span>';
	}
	
}
if (isset($_REQUEST['reset_list'])){
	delete_option('mc_list_id');
	delete_option('mc_list_name');
	delete_option('mc_merge_vars');
	delete_option('mc_interest_groups');

	delete_option('mc_header_content');
	delete_option('mc_submit_text');

	delete_option('mc_custom_style');
	delete_option('mc_form_border_width');
	delete_option('mc_form_border_color');
	delete_option('mc_form_background');
	delete_option('mc_form_text_color');

	$msg = '<span class="success_msg">Successfully Reset your List selection... Now you get to pick again!</span>';
}
if (isset($_REQUEST['change_form_settings'])){
	$content = stripslashes($_REQUEST['mc_header_content']);
	$content = str_replace("\r\n","<br/>", $content);
	update_option('mc_header_content', $content );

	$submit_text = stripslashes($_REQUEST['mc_submit_text']);
	$submit_text = str_replace("\r\n","", $submit_text);
	update_option('mc_submit_text', $submit_text);

	if (isset($_REQUEST['mc_custom_style'])){
		update_option('mc_custom_style','on');
	} else {
		update_option('mc_custom_style','off');
	}

	//we told them not to put these things we are replacing in, but let's just make sure they are listening...
	update_option('mc_form_border_width',str_replace('px','',$_REQUEST['mc_form_border_width']) );
	update_option('mc_form_border_color', str_replace('#','',$_REQUEST['mc_form_border_color']));
	update_option('mc_form_background',str_replace('#','',$_REQUEST['mc_form_background']));
	update_option('mc_form_text_color', str_replace('#','',$_REQUEST['mc_form_text_color']));

	if (isset($_REQUEST['mc_show_interest_groups'])){
		update_option('mc_show_interest_groups','on');
	} else {
		update_option('mc_show_interest_groups','off');
	}
	$mv = get_option('mc_merge_vars');
	if (!is_array($mv)){ 
	    $mv = unserialize(get_option('mc_merge_vars'));
	}
	foreach($mv as $var){
		$opt = 'mc_mv_'.$var['tag'];
		if (isset($_REQUEST[$opt]) || $var['req']=='Y'){
			update_option($opt,'on');
		} else {
			update_option($opt,'off');
		}
	}
	$msg = '<span class="success_msg">Successfully Updated your List Subscribe Form Settings!</span>';

}
if ($msg){
	echo '<div id="message" class="updated fade"><p><strong>'.$msg.'</strong></p></div>';
}
?>
<form method="post" action="options-general.php?page=mc_setup_page">
<?php wp_nonce_field('update-options'); ?>
<h3>Login Info</h3>
To start using the MailChimp plugin, we first need to store your MailChimp Username & Password<br/>
<table class="form-table">
<tr valign="top">
<th scope="row">Username:</th>
<td><input name="mc_username" type="text" id="mc_username" class="code" value="<?php echo $user; ?>" size="20" /></td>
</tr>
<tr valign="top">
<th scope="row">Password:</th>
<td><input name="mc_password" type="text" id="mc_password" class="code" value="<?php echo $pass; ?>" size="20" /></td>
</tr>
<tr valign="top">
<th scope="row">Monkey Rewards:</th>
<td><input name="mc_rewards" type="checkbox" <?php if (get_option('mc_rewards')=='on' || get_option('mc_rewards')=='' ) {echo 'checked';} ?> id="mc_rewards" class="code" />
<i>turning this on will place a "powered by MailChimp" link in your form that will earn you credits with us. It is optional and can be turned on or off at any time.</i>
</td>
</tr>
</table>

<p class="submit">
<input type="hidden" name="action" value="update"/>
<input type="hidden" name="page_options" value="mc_username,mc_password" />
<input type="submit" name="Submit" value="Save & Check" class="button" />
<?php 
if (get_option('mc_username')!=''){
	echo '<strong>Notes:</strong><ul>
		<li><i>Changing your settings at MailChimp.com may cause this to stop working.</i></li>
		<li><i>Changing your username &amp; password at MailChimp.com will cause this plugin to stop working!</i></li>
		<li><i>If you change your login to a different account, the info you have setup below will be erased.</i></li>
		<li><i>If any of that happens, no biggie - just reconfigure your login and the items below...</i></li></ul>
	<br/>';
}
?>
</p>
</form>
<?php
//Just get out if nothing else matters...
if (get_option('mc_username') == '') return;

if (get_option('mc_list_id')==''){
?>
<form method="post" action="options-general.php?page=mc_setup_page">
<?php wp_nonce_field('update-options'); ?>
<h3>Your Lists</h3>
Please select the List you wish to create a Signup Form for.<br/>
<?php
	$api = new MCAPI(get_option('mc_username'), get_option('mc_password'));
	$lists = $api->lists();
	rsort($lists);
	foreach ($lists as $list){
		echo '<input type="radio" name="mc_list_id" value="'.$list['id'].'"> &nbsp; <strong>'.$list['name'].'</strong><br/>';
	}
	if (sizeof($lists)==0){
		echo "<span class='error_msg'>Uh-oh, you don't have any lists defined! Please visit <a href='http://www.mailchimp.com/'>MailChimp</a>, login, and setup a list before using this tool!</span>";
	}
?>
<p class="submit">
<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="mc_list_id" />
<input type="submit" name="Submit" value="Select List!" class="button" />
</p>
</form>
<?php
} //end select list
else {
//display the selected list...
?>
<form method="post" action="options-general.php?page=mc_setup_page">
<?php wp_nonce_field('update-options'); ?>
<p class="submit">
<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="mc_list_id" />
<input type="submit" name="reset_list" value="Reset List Options and Select again" class="button" />
</p>
</form>
<h3>Subscribe Form Widget Settings for this List:</h3>
<h4>Selected MailChimp List: <?php echo get_option('mc_list_name'); ?></h4>
<?php
}
//Just get out if nothing else matters...
if (get_option('mc_list_id') == '') return;
$mv = get_option('mc_merge_vars');
$ig = get_option('mc_interest_groups');
if (!is_array($mv)){
    //apparently in WP 2.6 get_option() unserializes arrays for us.
    $mv = unserialize($mv);
    $ig = unserialize($ig);
}
if (!is_array($ig)){
    //means we got false returned
   $ig = unserialize($ig);
}
?>
<form method="post" action="options-general.php?page=mc_setup_page">
<?php wp_nonce_field('update-options'); ?>
<div style="width:600px;">
<table class="widefat">
	<tr valign="top">
	<th scope="row">Header content:</th>
	<td>
	<textarea name="mc_header_content" cols="50"><?php echo get_option('mc_header_content');?></textarea><br/>
	<i>You can fill this with your own Text, HTML markup (including image links), or Nothing!</i>
	</td>
	</tr>

	<tr valign="top">
	<th scope="row">Submit Button text:</th>
	<td>
	<input type="text" name="mc_submit_text" size="30" value="<?php echo get_option('mc_submit_text');?>"/><br/>
	<i>You can fill this with your own Text, HTML markup (including image links), or Nothing!</i>
	</td>
	</tr>

	<tr valign="top">
	<th scope="row">Custom Styling:</th>
	<td>
	<table class="widefat">
		<tr><th>Turned On?</th><td><input type="checkbox" name="mc_custom_style" <?php if (get_option('mc_custom_style')=='on'){echo 'checked';}?> ></td></tr>
		<tr><th>Border Width:</th><td><input type="text" name="mc_form_border_width" size="3" maxlength="3" value="<?php echo get_option('mc_form_border_width');?>"> px<br/>
			<i>Set to 0 for no border, do not enter <strong>px</strong>!</i>
		</td></tr>
		<tr><th>Border Color:</th><td>#<input type="text" name="mc_form_border_color" size="7" maxlength="6" value="<?php echo get_option('mc_form_border_color');?>"><br/>
			<i>do not enter initial <strong>#</strong></i>
		</td></tr>
		<tr><th>Text Color:</th><td>#<input type="text" name="mc_form_text_color" size="7" maxlength="6" value="<?php echo get_option('mc_form_text_color');?>"><br/>
			<i>do not enter initial <strong>#</strong></i>
		</td></tr>
		<tr><th>Background Color:</th><td>#<input type="text" name="mc_form_background" size="7" maxlength="6" value="<?php echo get_option('mc_form_background');?>"><br/>
			<i>do not enter initial <strong>#</strong></i>
		</td></tr>
	</table>
</td>
</tr>
</table>
</div>

<div style="width:400px;">
<h4>Merge Variables Included</h4>
<?php
if (sizeof($mv)==0){
	echo "<i>No Merge Variables found.</i>";
} else {
	?>
	
	<table class='widefat'>
	<tr valign="top">
	<th>Name</th>
	<th>Tag</th>
	<th>Required?</th>
	<th>Include?</th>
	</tr>
	<?php
	foreach($mv as $var){
		echo '<tr valign="top">
			<td>'.$var['name'].'</td>
			<td>'.$var['tag'].'</td>
			<td>'.($var['req']==1?'Y':'N').'</td><td>';
		if (!$var['req']){
			$opt = 'mc_mv_'.$var['tag'];
			echo '<input name="'.$opt.'" type="checkbox" ';
			if (get_option($opt)=='on') { echo ' checked '; }
			echo 'id="'.$opt.'" class="code" />';
		} else {
			echo ' - ';
		}
		echo '</td></tr>';
	}
	echo '</table>';
}
echo '<h4>Interest Groups</h4>';
if (!$ig || $ig=='' || $ig=='N'){
	echo "<i>No Interest Groups Setup for this List</i>";
} else {
	?>
	<table class='widefat'>
	<tr valign="top">

	<th width="75px">Show?</th><th>
	<input name="mc_show_interest_groups" type="checkbox" <?php if (get_option('mc_show_interest_groups')=='on') { echo 'checked'; } ?> id="mc_show_interest_groups" class="code" />
	</th></tr>
	<tr valign="top">
	<th>Name:</th><th><?php echo $ig['name']; ?></th>
	</tr>
	<tr valign="top">
	<th>Input Type:</th><td><?php echo $ig['form_field']; ?></td>
	</tr>
	<tr valign="top">
	<th>Options:</th><td><ul>
	<?php
	foreach($ig['groups'] as $interest){
		echo '<li>'.$interest;
	}
	echo '</ul></td></tr></table>';
}
echo '</div>';
?>
<p class="submit">
<input type="hidden" name="action" value="update" />
<input type="submit" name="change_form_settings" value="Update Subscribe Form Settings" class="button" />
</p>
</form>
</div>
<?php
}//mc_setup_page()


add_action('plugins_loaded', 'mc_register_widgets');
function mc_register_widgets(){

	if (!function_exists('register_sidebar_widget')) {
		return;
	}
	register_sidebar_widget('MailChimp Widget', 'mc_display_widget');

}
function mc_display_widget(){
    $mv = get_option('mc_merge_vars');
    $ig = get_option('mc_interest_groups');
    if (!is_array($mv)){
        //apparently in WP 2.6 get_option() unserializes arrays for us.
        $mv = unserialize($mv);
        $ig = unserialize($ig);
    }

	$msg = '';
	if (isset($_REQUEST['mc_signup'])){
		$failed = false;
    		$listId = get_option('mc_list_id');
		$email = $_REQUEST['mc_mv_EMAIL'];
		$merge = array();
		$errs = array();
		foreach($mv as $var){
			$opt = 'mc_mv_'.$var['tag'];
			if ($var['req']=='Y' && trim($_REQUEST[$opt])==''){
				$failed = true;
				$errs[] = 'You must fill in "'.$var['name'].'"!';
			} else {
				if ($var['tag']!='EMAIL'){
					$merge[$var['tag']] = $_REQUEST[$opt];
				}
			}	
		}
		reset($mv);
		if (get_option('mc_show_interest_groups')){
			if ($ig['form_field']=='radio' || $ig['form_field']=='select'){
				$merge['INTERESTS'] = $_REQUEST['interests'];
			} elseif($ig['form_field']=='checkbox') {
				if (isset($_REQUEST['interests'])){
					$merge['INTERESTS'] = implode(',',array_keys($_REQUEST['interests']));
				}
			}
		}
		if (!$failed){
		    foreach($merge as $k=>$v){
		        if (trim($v)===''){
		            unset($merge[$k]);
		        }
		    }
			if (sizeof($merge) == 0 || $merge==''){ $merge = ''; }
			
			$api = new MCAPI(get_option('mc_username'), get_option('mc_password'));
			$retval = $api->listSubscribe( $listId, $email, $merge);
			if (!$retval){
				$failed = true;
				$errs[] = $api->errorMessage;
			} else {
				$msg = "<br/><strong class='success_msg'>Success, you've been signed up! Please look for our confirmation email!</strong><br/>";
			}
		}
		if (sizeof($errs)>0){
			$msg = '<br/>Uhoh, we had problems!<ul>';
			foreach($errs as $error){
				$msg .= '<li class="error_msg">'.$error.'</li>';
			}
			$msg .= '</ul><br/>';
		}
	}
	$uid = get_option('mc_user_id');
	$list_name = get_option('mc_list_name');
	?>
	<div class="mc_custom_border">
	<a name="mc_signup_form"></a>
	<?php echo get_option('mc_header_content');?>
	<form method="POST" action="<?php echo $_SERVER['REQUEST_URI']; ?>#mc_signup_form">
	<?php
	if ($msg != ''){
		echo '<span class="updated">'.$msg.'</span>';
	}
	foreach($mv as $var){
		$opt = 'mc_mv_'.$var['tag'];
		if ($var['req'] || get_option($opt)=='on'){
			echo ''.$var['name'].':<br/><input type="text" size="18" value="" name="'.$opt.'">';
			if ($var['req']){ echo '*'; }
			echo '<br/>';
		}
	}
	echo '<sup style="clear:both;">* = required field</sup>';
	if (get_option('mc_show_interest_groups')=='on'){
		echo '<br/><br/><strong>'.$ig['name'].'</strong><br/>';
		if ($ig['form_field']=='checkbox'){
			foreach($ig['groups'] as $interest){
				echo '<input type="checkbox" name="interests['.$interest.']">'.$interest.'<br/>';
			}
		} elseif ($ig['form_field']=='radio'){
			foreach($ig['groups'] as $interest){
				echo '<input type="radio" name="interests">'.$interest.'<br/>';
			}
		} elseif ($ig['form_field']=='select'){
			echo '<select name="interests">';
			foreach($ig['groups'] as $interest){
				echo '<option value="'.$interest.'">'.$interest.'</option>';
			}
			echo '</select>';
		}
	}
	?>
	<div class="submit">
	<input type="submit" name="mc_signup" value="<?php echo get_option('mc_submit_text'); ?>" class="button"/>
	</div>
	</form>
	<?php
	if ( get_option('mc_rewards')=='on') {
		echo '<div align="center">powered by <a href="http://www.mailchimp.com/affiliates/?aid='.get_option('mc_user_id').'&afl=1">MailChimp</a>!</div>';
	}
	?>
	</div>
	<?php

}

?>
